;
; car trip computer
; 07/01/02 setting up
; 25/06/06 added RPM
; 05/07/06 added over speed alarm
; 11/07/06 added litres per hour
; 26/07/06 added trip meter and time remaining to destination
; 30/07/06 added cost for fuel and cost per km
; 06/08/06 added new and mod to cost and fuel tank
; 15/07/07 increased crystal from 4 to 8 MHz
;          added range and average range remaining in fuel tank
; 30/07/07 increased resolution of fuel tank
; 17/09/07 added duty cycle and changed RPM resolution from 120 to 1
; 27/07/10 16F876 TO 18F252, Added FUEL_RES, remove leading zero's
;          added MOD_TMP_L and mod flag to DIST_TRIP
;          added HR_H, fuel used now uses its own distance cnt
;          added more digits to $, km and fuel
;          increased TIMEOUT to 10 secs
; 05/08/10 fixed PCLATH problem, added wrap around for 98 and 99 func's
; 10/12/10 added MODE1,4 to RB0_INT to solve missing sec's in trip time
;          changed timer value in TMR0_INT from E0C6 to E0C9
; 23/01/11 Added extra digit to L/100
;          fixed O_SPEED_H should be O_SPEED_L in KM_H
; 25/04/11 use CCP2 for fuel input
; 28/04/11 fixed CCP2 lockout on rising edge problem
; 03/08/11 added TOLL to fuel and km cost
;
  LIST P=18F252
  ERRORLEVEL      -302    ;SUPPRESS BANK SEL
  include <P18f252.inc>
;
DIST_CAL_H      EQU     0x000
DIST_CAL_L      EQU     0x001
FUEL_CAL_H      EQU     0x002
FUEL_CAL_L      EQU     0x003
FUNC1           EQU     0x004
COST_H          EQU     0x005   ; X.XXX
COST_L          EQU     0x006
COST_KM         EQU     0x007
NO_PEOPLE       EQU     0x008   ; 0x
FUEL_RES        EQU     0x009   ; xx
;
COST_TRIP_0     EQU     0x00A   ; XXXXX.XXXXX
COST_TRIP_1     EQU     0x00B
COST_TRIP_2     EQU     0x00C
COST_TRIP_3     EQU     0x00D
COST_TRIP_4     EQU     0x00E
HRS_H           EQU     0x00F
HRS             EQU     0x010
MIN             EQU     0x011
SEC             EQU     0x012
DIST_H          EQU     0x013
DIST_L          EQU     0x014
O_SPEED_H       EQU     0x015
O_SPEED_L       EQU     0x016
FUEL0           EQU     0x017   ; XXXXX.XXXXXXX
FUEL1           EQU     0x018
FUEL2           EQU     0x019
FUEL3           EQU     0x01A
FUEL4           EQU     0x01B
FUEL5           EQU     0x01C
DIST_T_1        EQU     0x01D   ; XXXXX.X
DIST_T_2        EQU     0x01E
DIST_T_3        EQU     0x01F
DIST_TRIP_H     EQU     0x020   ; XXX.X
DIST_TRIP_L     EQU     0x021
FUEL_TANK_H     EQU     0x022   ; XXXX.XX
FUEL_TANK_L     EQU     0x023
FUEL_TANK_100   EQU     0x024   ; .xHM H= 1/100 digit M= 1/100 modify digit
FUNC            EQU     0x025
DIST_F_1        EQU     0x026   ; XXXXX.X
DIST_F_2        EQU     0x027
DIST_F_3        EQU     0x028
TOLL1           EQU     0x029   ; xxxx.xx
TOLL2           EQU     0x02A
TOLL3           EQU     0x02B
FUEL_MULT       EQU     0x02C   ; x.x
;
CYCLE_L         EQU     0x03D
CYCLE_H         EQU     0x03E
CYCLE_OF        EQU     0x03F
CYCLE1          EQU     0x040
CYCLE2          EQU     0x041
CYCLE3          EQU     0x042
MSD             EQU     0x043
LSD             EQU     0x044
CNT1            EQU     0x045
CNT3            EQU     0x046
KEY             EQU     0x047
DIST_1_H        EQU     0x048
DIST_1_L        EQU     0x049
FUEL_U_1        EQU     0x04A   ; XX.XXXX Ml/Sec
FUEL_U_2        EQU     0x04B
FUEL_U_3        EQU     0x04C
TEMP2           EQU     0x04D
DIST_L_H        EQU     0x04E
DIST_L_L        EQU     0x04F
DIV1            EQU     0x050
DIV2            EQU     0x051
DIV3            EQU     0x052
DIV4            EQU     0x053
DIV5            EQU     0x054
DIV6            EQU     0x055
DIV7            EQU     0x056
DIV8            EQU     0x057
DIV9            EQU     0x058
DIV10           EQU     0x059
DIV11           EQU     0x05A
DIV12           EQU     0x05B
BEEP_DELAY      EQU     0x05C
TMR1_OF         EQU     0x05D
KM_H_H          EQU     0x05E
TEMP            EQU     0x05F
TEMP1           EQU     0x060
TEMP3           EQU     0x061
CHAR            EQU     0x062
CYCLE_CNT_L     EQU     0x063
FUEL_L_1        EQU     0x064
FUEL_L_2        EQU     0x065
FUEL_L_3        EQU     0x066
RPM             EQU     0x067
RPM_L           EQU     0x068
TIMEOUT         EQU     0x069
PORT_OLD        EQU     0x06A
DIST_TRAV_L     EQU     0x06B
DIST_TRAV_H     EQU     0x06C
KM_H_L          EQU     0x06D
DATA_MOD        EQU     0x06E
MODE1           EQU     0x06F
W_S             EQU     0x070
STATUS_S        EQU     0x071
TMR0L_TMP       EQU     0x072
BITS_BYTE       EQU     0x073
MOD_TMP_H       EQU     0x074
UPDATE1         EQU     0x075
CYCLE_CNT       EQU     0x076
CNT4            EQU     0x077
PORT_TMP        EQU     0x078
TMR1H_TMP       EQU     0x079
TMR1L_TMP       EQU     0x07A
MOD_TMP_L       EQU     0x07B
TMR1_OF_TMP     EQU     0x07C
KEY_DELAY       EQU     0x07D
FUEL_MOD_H      EQU     0x07E
FUEL_MOD_L      EQU     0x07F
;
; EEPROM 0 - 35 used
; EEPROM 36 - 255 unused
;
;BITS_BYTE,0
;BITS_BYTE,1 beep enable, over speed
;BITS_BYTE,2 fuel mod or new entry
;BITS_BYTE,3 blank leading zero's flag
;BITS_BYTE,4 key flag
;BITS_BYTE,5 key flag
;BITS_BYTE,6 mode/entry flag
;BITS_BYTE,7 function mod flag
;
;FUNC1 0 EEPROM write check
;      1 fuel cal flag
;      2 dist cal flag
;      3
;      4
;      5
;      6
;      7
;
;MODE1 0 car moved
;      1 timer 1
;      2 ignition on or off
;      3 1 sec flag
;      4 motor running
;      5 power down flag
;      6 2 beeps
;      7 2 beeps
;
; RA0 2 voltage sense input
; RA1 3 up button
; RA2 4 down button
; RA3 5 mode/enter button
; RA4 6 buzzer
; RA5 7 clear/reset button
;
; RB0 21 distance input inverted
; RB1 22 E LCD
; RB2 23 power hold
; RB3 24 fuel input inverted (CCP2 on 18F series)
; RB4 25
; RB5 26 igition on or off sense (not inverted)
; RB6 27 RS LCD
; RB7 28 R/W LCD
;
; RC0 11 DB0 LCD
; RC1 12 DB1 LCD
; RC2 13 DB2 LCD
; RC3 14 DB3 LCD
; RC4 15 DB4 LCD
; RC5 16 DB5 LCD
; RC6 17 DB6 LCD
; RC7 18 DB7 LCD
;
; VDD 20 +5V
; VSS 8,19 GND
;
; OSC1 9 (8.0MHz crystal)
; OSC2 10
;
; MCLR 1
;
; Func 0x fuel mult, number of people in car, tolls, amount per person
;      1x cents per km, Tolls/number of people, amount for total km's
;      2x distance travelled, time elapsed (motor running)
;      3x trip distance remainig, time to destination, average time to destination
;      4x battery voltage
;      5x fuel used, L/hr or L/100 km's, averge L/100 km's
;      6x km/hr, RPM, over speed value (when turned on)
;      7x over speed value and disable
;      8x average injector on time, duty cycle %, ml/sec
;      90 new or mod, cost/litre, amount left in fuel tank, range, average range
;      91 fuel used (used for calibration)
;      92 fuel calabration value
;      93 fuel calabration on or off
;      94 distance travelled (used for calibration)
;      95 distace calibration value
;      96 distance calibration on or off
;      97 fuel reserve or unuseable
;      98 not used
;      99 not used
;
            org     0x0000          ; RESET vector location
BEGIN       CLRF    STATUS          ; Do initialization
            CLRF    INTCON          ; Disable all interrupts
            GOTO    START
;
            org     0x0008          ; Interrupt vector location
INT_V       MOVWF   W_S             ; save reg's
            SWAPF   STATUS,W
            MOVWF   STATUS_S
;
CCP2_INT    BTFSS   PIR2,0          ; CCP2 int
            BRA     TMR1_INT
;
            BCF     PIR2,0          ; clear CCP2 int

            BTFSS   CCP2CON,0
            BRA     CCP2_INT2

            MOVF    CCPR2L,W
            ADDWF   CYCLE_L,F
;
            MOVF    CCPR2H,W
            ADDWFC  CYCLE_H,F
;
            MOVF    TMR1_OF,W
            ADDWFc  CYCLE_OF,F
            BTFSC   CCPR2H,7
            BRA     CCP2_INT3
            BTFSC   PIR1,0          ; tmr1 overflow
            INCF    CYCLE_OF,F

CCP2_INT3   BCF     PIE2,0          ; disable CCP2 int
            BCF     CCP2CON,0       ; falling edge
            BCF     PIR2,0          ; clear CCP2 int
            BSF     PIE2,0          ; enable CCP2 int
;
;            BTFSC   T1CON,0
;            BRA     CCP2_INT0
;            CLRF    TMR1H
;            CLRF    TMR1L
;            BSF     T1CON,0         ; enable timer1
;            CLRF    TMR1_OF
;            BRA     CCP2_INT1
;
CCP2_INT0   MOVF    CCPR2L,W
            SUBWF   TMR1L,W
            MOVWF   TMR1_OF
            MOVF    CCPR2H,W
            SUBWFB  TMR1H,F
            MOVLW   0x09
            ADDWF   TMR1_OF,F
            MOVLW   0x00
            ADDWFC  TMR1H,F
            MOVF    TMR1_OF,W
            MOVWF   TMR1L
            CLRF    TMR1_OF
;
CCP2_INT1   BCF     PIR1,0          ; clear tmr1 overflow int
            BSF     MODE1,1
            MOVF    CYCLE_CNT,W
            CALL    ADD_1
            MOVWF   CYCLE_CNT
            BRA     TMR1_INT
;
CCP2_INT2   BTFSS   MODE1,1
            BRA     CCP2_INT5
            BCF     MODE1,1

            MOVF    CCPR2L,W
            ADDWF   TMR1L_TMP,F
;
            MOVF    CCPR2H,W
            ADDWFC  TMR1H_TMP,F
;
            MOVF    TMR1_OF,W
            ADDWFC  TMR1_OF_TMP,F
            BTFSC   CCPR2H,7
            BRA     CCP2_INT4
            BTFSC   PIR1,0          ; tmr1 overflow
            INCF    TMR1_OF_TMP,F
;
CCP2_INT4   BSF     MODE1,4         ; motor running
            MOVF    RPM, W
            CALL    ADD_1
            MOVWF   RPM
            MOVLW   0x0A
            MOVWF   TIMEOUT
;
CCP2_INT5   BCF     PIE2,0          ; disable CCP2 int
            BSF     CCP2CON,0       ; rising edge
            BCF     PIR2,0          ; clear CCP2 int
            BSF     PIE2,0          ; enable CCP2 int
;
TMR1_INT    BTFSS   PIR1,0          ; tmr1 overflow, timeout 65.536ms
            BRA     PORT_CH
            BCF     PIR1,0
            INCF    TMR1_OF,F
;
            MOVLW   0x03
            SUBWF   TMR1_OF,W
            BTFSC   STATUS, Z
            BCF     MODE1,1

PORT_CH     BTFSS   INTCON,0        ; port change
            BRA     TMR0_INT
;
            MOVF    PORTB,W         ; clr mismatch condition
            MOVWF   PORT_TMP
            XORWF   PORT_OLD,F
            BCF     INTCON,0        ; clear int (port change)
;
PORT_CH3    BTFSS   PORT_OLD,5      ; ignition switch
            BRA     PORT_CH5
;
            BTFSC   PORT_TMP,5
            BRA     PORT_CH4
;
            BSF     MODE1,2         ; ignition off
            BTFSS   MODE1,5
            BRA     PORT_CH5
            BSF     PORTB,2         ; power hold
            BCF     MODE1,5
            MOVLW   0x0A
            MOVWF   TIMEOUT
            BRA     PORT_CH5
;
PORT_CH4    BCF     MODE1,2         ; ignition on
;
PORT_CH5    MOVF    PORT_TMP,W
            MOVWF   PORT_OLD
;
TMR0_INT    BTFSS   INTCON,2        ; tmr0 overflowed
            BRA     RB0_INT
            BCF     INTCON,2        ; clear TMR0 int
            MOVF    TMR0L,W         ; timer value, freq is 8MHz/4/(65536-57536+9)=250Hz
            ADDLW   0xC9   
            MOVWF   TMR0L_TMP
            MOVLW   0xE0
            ADDWFC  TMR0H,F,0       ; read/write buffer
            MOVF    TMR0L_TMP,W
            MOVWF   TMR0L           ; increment is inhibited for 2 cycles, No prescaler
;
            INCF    UPDATE1, F
;
            MOVF    KEY_DELAY,W
            BTFSS   STATUS,Z
            DECF    KEY_DELAY,F
;
            MOVF    BEEP_DELAY,W
            BTFSC   STATUS,Z
            BRA     CHK_UPD
            DECFSZ  BEEP_DELAY,F
            BRA     CHK_UPD
;
            BTFSS   MODE1,6         ; 2 beeps
            BRA     BEEP1
            BSF     PORTA,4
            BCF     MODE1,6
            BSF     MODE1,7
            MOVLW   0x32            ; 200ms delay
            MOVWF   BEEP_DELAY
            BRA     CHK_UPD
;
BEEP1       BTFSS   MODE1,7
            BRA     BEEP2
            BCF     PORTA,4
            BCF     MODE1,7
            MOVLW   0x32            ; 200ms delay
            MOVWF   BEEP_DELAY
            BRA     CHK_UPD
;
BEEP2       BSF     PORTA,4
;
CHK_UPD     MOVF    UPDATE1, W
            XORLW   0xFA            ; compare byte counter with 250 
            BTFSS   STATUS, Z       ; skip if equal
            BRA     RB0_INT         ; not 1 second yet
;
            CLRF    UPDATE1
            BSF     MODE1,3         ; set 1 sec flag
;
            BTFSS   MODE1,2
            BRA     LATCH           ; ignition on
            MOVF    TIMEOUT,W
            BTFSS   STATUS,Z
            DECF    TIMEOUT,F
;
LATCH       MOVF    DIST_1_L, W
            MOVWF   DIST_L_L
            CLRF    DIST_1_L
            MOVF    DIST_1_H, W
            MOVWF   DIST_L_H
            CLRF    DIST_1_H
;
LATCH_1     MOVF    TMR1L_TMP,W
            MOVWF   FUEL_L_3
            MOVF    TMR1H_TMP,W
            MOVWF   FUEL_L_2
            MOVF    TMR1_OF_TMP,W
            MOVWF   FUEL_L_1
;
LATCH_2     CLRF    TMR1L_TMP
            CLRF    TMR1H_TMP
            CLRF    TMR1_OF_TMP
;
LATCH_3     MOVF    RPM,W
            MOVWF   RPM_L
            CLRF    RPM
;
LATCH_4     MOVF    CYCLE_L,W
            MOVWF   CYCLE3
            MOVF    CYCLE_H,W
            MOVWF   CYCLE2
            MOVF    CYCLE_OF,W
            MOVWF   CYCLE1
;
            CLRF    CYCLE_L
            CLRF    CYCLE_H
            CLRF    CYCLE_OF
            MOVF    CYCLE_CNT,W
            MOVWF   CYCLE_CNT_L
            CLRF    CYCLE_CNT
;
RB0_INT     BTFSS   INTCON,1        ; RB0
            BRA     FIN
;
            BCF     INTCON,1        ; clear RB0 int
            BSF     MODE1,0         ; car moved
            BSF     MODE1,4         ; motor running and moving
            MOVF    DIST_1_L, W
            CALL    ADD_1
            MOVWF   DIST_1_L
            BTFSS   STATUS, Z
            BRA     RB0_1
            MOVF    DIST_1_H ,W
            CALL    ADD_1
            MOVWF   DIST_1_H
;
RB0_1       MOVF    DIST_L, W
            CALL    ADD_1
            MOVWF   DIST_L
            BTFSS   STATUS, Z
            BRA     RB0_2
            MOVF    DIST_H ,W
            CALL    ADD_1
            MOVWF   DIST_H
;
            BTFSS   FUNC1,2         ; dist cal mode
            BRA     RB0_20
            BTFSS   STATUS, Z
            BRA     FIN
            MOVF    DIST_T_1, W
            CALL    ADD_1
            MOVWF   DIST_T_1
            BRA     FIN
;
RB0_2       BTFSC   FUNC1,2         ; dist cal mode
            BRA     FIN
;
RB0_20      MOVF    DIST_H ,W
            XORWF   DIST_CAL_H, W
            BTFSS   STATUS, Z       ; skip if equal
            BRA     FIN             ; not
            MOVF    DIST_L, W
            XORWF   DIST_CAL_L, W 
            BTFSS   STATUS, Z       ; skip if equal
            BRA     FIN             ; not
;
            CLRF    DIST_L
            CLRF    DIST_H
            MOVF    DIST_T_3, W
            CALL    ADD_1
            MOVWF   DIST_T_3
            BTFSS   STATUS, Z
            BRA     RB0_21
;
            MOVF    DIST_T_2, W
            CALL    ADD_1
            MOVWF   DIST_T_2
            BTFSS   STATUS, Z
            BRA     RB0_21
;
            MOVF    DIST_T_1, W
            CALL    ADD_1
            MOVWF   DIST_T_1
;
RB0_21      MOVF    DIST_F_3, W
            CALL    ADD_1
            MOVWF   DIST_F_3
            BTFSS   STATUS, Z
            BRA     RB0_3
;
            MOVF    DIST_F_2, W
            CALL    ADD_1
            MOVWF   DIST_F_2
            BTFSS   STATUS, Z
            BRA     RB0_3
;
            MOVF    DIST_F_1, W
            CALL    ADD_1
            MOVWF   DIST_F_1
;
RB0_3       MOVF    DIST_TRIP_L,W   ; check for zero
            IORWF   DIST_TRIP_H,W
            BTFSC   STATUS, Z
            BRA     FIN
;
            MOVF    DIST_TRIP_L, W
            CALL    SUB_1
            MOVWF   DIST_TRIP_L
            BTFSC   STATUS, C
            BRA     FIN
;
            MOVF    DIST_TRIP_H, W
            CALL    SUB_1
            MOVWF   DIST_TRIP_H
;
FIN         SWAPF   STATUS_S,W      ; restore reg's
            MOVWF   STATUS
            SWAPF   W_S,F
            SWAPF   W_S,W
            RETFIE
;
START       MOVLW   0x0E
            MOVWF   ADCON1          ; left justified, RA0 input
            MOVLW   0x2F
            MOVWF   TRISA
            MOVLW   0x29
            MOVWF   TRISB
            MOVLW   0x00
            MOVWF   TRISC           ; all outputs
            MOVLW   0xC5
            MOVWF   INTCON2         ; rising edge of RB0, pullups disabled - option_reg
            BSF     RCON,1          ; power-on reset - PCON
            BSF     RCON,0          ; brown-out reset
            CLRF    CYCLE_L
            CLRF    CYCLE_H
            CLRF    CYCLE_OF
            MOVLB   0x00
;
            MOVLW   0x10
            MOVWF   PORTA
            MOVLW   0x04
            MOVWF   PORTB           ; enable power hold
            MOVLW   0x91
            MOVWF   T1CON           ; tmr1 1:2, timer enabled, 7/0 two 8-bit operations (7/1 one 16-bit operation)
            CLRF    MODE1
            CLRF    BITS_BYTE
            CLRF    TMR1L_TMP
            CLRF    TMR1H_TMP
            CLRF    TMR1_OF_TMP
            CLRF    CYCLE_CNT
            CLRF    KEY_DELAY
            CLRF    BEEP_DELAY
            CLRF    UPDATE1
            CLRF    DIST_1_H
            CLRF    DIST_1_L
            CLRF    FUEL_MOD_H
            CLRF    FUEL_MOD_L
            CLRF    RPM
            CLRF    KM_H_H
            CLRF    KM_H_L
            MOVF    PORTB,W         ; clr mismatch condition
            MOVWF   PORT_OLD
            MOVLW   0x0A
            MOVWF   TIMEOUT
;
            LFSR    FSR0,0x000
INIT_CAL1   MOVF    FSR0L,W
            CALL    EE_READ
            MOVWF   POSTINC0
            MOVF    FSR0L,W
            SUBLW   0x2D
            BTFSS   STATUS,Z
            BRA     INIT_CAL1
;
            MOVLW   0x06
            ANDWF   FUNC1,F
;
LCD_DELAY   MOVLW   0x4E          ; 30ms
            MOVWF   TEMP1
            CLRF    TEMP3
LOOP2       DECFSZ  TEMP3, F        ; Delay time = TEMP1 * ((3 * 256) + 3) * Tcy
            BRA     LOOP2
            DECFSZ  TEMP1, F
            BRA     LOOP2
;
INIT_DISP   MOVLW   0x38          ; 8 bits, 2 line, 5x7
            CALL    SEND_INS
            MOVLW   0x0C          ; D-on , C-off, B-off
            CALL    SEND_INS
            MOVLW   0x06          ; inc D, no shift
            CALL    SEND_INS
;
            MOVLW   0xE1          ; 8MHz/4/(65536-57536)=250Hz
            MOVWF   TMR0H
            MOVLW   0xC0
            MOVWF   TMR0L
            MOVLW   0x88
            MOVWF   T0CON         ; tmr0 is configured as an 16-bit timer/counter, no prescaler
            MOVLW   0x80
            MOVWF   T3CON         ; tmr1 is the clock source for capture, stop tmr3
            MOVLW   0x05
            MOVWF   CCP2CON       ; rising edge on CCP2
            BCF     PIR1,0        ; clear tmr1 overflow int
            BSF     PIE1,0        ; enable tmr1 overflow int
            BCF     PIR2,0        ; clear CCP2 int
            BSF     PIE2,0        ; enable CCP2 int
            BCF     INTCON,1      ; clear RB0 int
            BCF     INTCON,0      ; clear port change int
            BCF     INTCON,2      ; clear TMR0 int
            MOVLW   0xF8          ; enable RB0, port change, TMR0
            MOVWF   INTCON
;
CHK_FUNC    MOVLW   0x01          ; clr display
            CALL    SEND_INS
;
CHK_F       MOVLW   0x80
            CALL    SEND_INS
;
            SWAPF   FUNC,W
            ANDLW   0x0F
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     CHK_FUNC00
            BRA     CHK_FUNC10
            BRA     CHK_FUNC20
            BRA     CHK_FUNC30
            BRA     CHK_FUNC40
            BRA     CHK_FUNC50
            BRA     CHK_FUNC60
            BRA     CHK_FUNC70
            BRA     CHK_FUNC80
            BRA     CHK_FUNC90
;
CHK_FUNC00  SWAPF   FUEL_MULT,W   ; mult factor
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL_MULT,W   ; mult factor
            CALL    HEX_A
            CALL    CLR_CHAR
            MOVF    NO_PEOPLE,W   ; number of people
            CALL    HEX_A
            CALL    CLR_CHAR
            MOVLW   '$'
            CALL    SEND_CHAR
            MOVF    TOLL1,W
            CALL    ASCII_Z2
            MOVF    TOLL2,W
            CALL    ASCII_Z0
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    TOLL3,W
            CALL    ASCII
;
            MOVF    COST_TRIP_0,W
            MOVWF   DIV1
            MOVF    COST_TRIP_1,W
            MOVWF   DIV2
            MOVF    COST_TRIP_2,W
            MOVWF   DIV3
            MOVF    COST_TRIP_3,W
            MOVWF   DIV4
            CLRF    DIV11
            MOVF    FUEL_MULT,W
            MOVWF   DIV12
            CALL    MULT
;
            MOVF    DIV6,W
            MOVWF   DIV1
            MOVF    DIV7,W
            MOVWF   DIV2
            MOVF    DIV8,W
            MOVWF   DIV3
            MOVF    DIV9,W
            MOVWF   DIV4
            CLRF    DIV5
            MOVF    TOLL1,W
            MOVWF   DIV6
            MOVF    TOLL2,W
            MOVWF   DIV7
            MOVF    TOLL3,W
            MOVWF   DIV8    
            CALL    DIV_7        ; add
;
            MOVF    DIV6,W
            MOVWF   DIV9
            MOVF    DIV7,W
            MOVWF   DIV10
            MOVF    DIV8,W
            MOVWF   DIV11
;
            CLRF    DIV1
            CLRF    DIV2
            CLRF    DIV3
            MOVF    NO_PEOPLE,W
            ANDLW   0x0F
            MOVWF   DIV4
            CALL    DIV_000
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            MOVLW   '$'
            CALL    SEND_CHAR
            MOVF    DIV9,W
            CALL    ASCII_Z2
            MOVF    DIV10,W
            CALL    ASCII_Z0
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV11,W
            CALL    ASCII
;
            CALL    CLR_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'P'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC10  MOVF    COST_KM,W     ; cost/km
            CALL    ASCII
;
            BTFSC   FUNC1,2       ; dist cal mode
            GOTO    DISP_FUNC
;
            MOVF    TOLL1,W
            MOVWF   DIV9
            MOVF    TOLL2,W
            MOVWF   DIV10
            MOVF    TOLL3,W
            MOVWF   DIV11
;
            CLRF    DIV1
            CLRF    DIV2
            CLRF    DIV3
            MOVF    NO_PEOPLE,W
            ANDLW   0x0F
            MOVWF   DIV4
            CALL    DIV_000
;
            CALL    CLR_CHAR
            MOVLW   '$'
            CALL    SEND_CHAR
            MOVF    DIV9,W
            MOVWF   TEMP1
            CALL    ASCII_Z2
            MOVF    DIV10,W
            MOVWF   TEMP2
            CALL    ASCII_Z0
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV11,W
            MOVWF   TEMP3
            CALL    ASCII
;
            CLRF    DIV1          ; cost for trip per km
            MOVF    DIST_T_1,W
            MOVWF   DIV2
            MOVF    DIST_T_2,W
            MOVWF   DIV3
            MOVF    DIST_T_3,W
            MOVWF   DIV4
            SWAPF   COST_KM,W
            ANDLW   0x0F
            MOVWF   DIV11
            SWAPF   COST_KM,W
            ANDLW   0xF0
            MOVWF   DIV12
            CALL    MULT
;
            CLRF    DIV1
            MOVF    TEMP1,W
            MOVWF   DIV2
            MOVF    TEMP2,W
            MOVWF   DIV3
            MOVF    TEMP3,W
            MOVWF   DIV4
            MOVF    DIV6,W
            MOVWF   DIV5
            MOVF    DIV7,W
            MOVWF   DIV6
            MOVF    DIV8,W
            MOVWF   DIV7
            MOVF    DIV9,W
            MOVWF   DIV8
            CALL    DIV_7        ; add
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            MOVLW   '$'
            CALL    SEND_CHAR
            MOVF    DIV6,W
            CALL    ASCII_Z2
            MOVF    DIV7,W
            CALL    ASCII_Z0
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV8,W
            CALL    ASCII
;
            CALL    CLR_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'k'
            CALL    SEND_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
;
DISP_FUNC   BTFSS   BITS_BYTE,7
            GOTO    CHK_KEY
            MOVF    CNT4,W        ; pos display
            CALL    SEND_INS
            GOTO    CHK_KEY
;
CHK_FUNC20  BTFSS   FUNC1,2       ; dist total/dist cal mode
            BRA     CHK_FUNC201
            MOVF    DIST_T_1, W
            CALL    ASCII
            MOVF    DIST_H, W     ; dist counter
            CALL    ASCII
            MOVF    DIST_L, W
            CALL    ASCII
            BRA     CHK_FUNC202
;
CHK_FUNC201 MOVF    DIST_T_1, W
            CALL    ASCII_Z2
            MOVF    DIST_T_2, W
            CALL    ASCII_ZC
            SWAPF   DIST_T_3, W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIST_T_3, W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'k'
            CALL    SEND_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
;
CHK_FUNC202 MOVLW   0xC0          ; pos display
            CALL    SEND_INS
;
            MOVF    HRS_H, W      ; clock
            CALL    ASCII_Z2
            MOVF    HRS, W
            CALL    ASCII_Z0
            MOVLW   ':'
            CALL    SEND_CHAR
            MOVF    MIN, W
            CALL    ASCII
            MOVLW   ':'
            CALL    SEND_CHAR
            MOVF    SEC, W
            CALL    ASCII
            GOTO    DISP_FUNC
;
CHK_FUNC30  BTFSC   FUNC1,2       ; dist trip/dist cal
            GOTO    DISP_FUNC
;
            BTFSC   BITS_BYTE,7
            BRA     CHK_FUNC34
            MOVF    DIST_TRIP_H, W
            CALL    ASCII_Z2
            SWAPF   DIST_TRIP_L, W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIST_TRIP_L, W
CHK_FUNC35  CALL    HEX_A
            MOVLW   'k'
            CALL    SEND_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
            CALL    CLR_CHAR
;
            BTFSC   MODE1,0       ; car moved - dist trip rem
            BRA     CHK_FUNC31
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            BRA     CHK_FUNC32
;
CHK_FUNC31  BCF     MODE1,0
            CLRF    DIV1
            CLRF    DIV2
            MOVF    KM_H_H,W
            MOVWF   DIV3
            MOVF    KM_H_L,W
;
            CALL    CHK_FUNC33
;
CHK_FUNC32  MOVLW   0xC8          ; pos display
            CALL    SEND_INS
;
            CALL    AVG_SPD
            MOVF    DIV9,W
            MOVWF   DIV1
            MOVF    DIV10,W
            MOVWF   DIV2
            MOVF    DIV11,W
            MOVWF   DIV3
            MOVF    DIV12,W
            CALL    CHK_FUNC33
            GOTO    DISP_FUNC
;
CHK_FUNC33  MOVWF   DIV4
            MOVF    DIST_TRIP_H,W
            MOVWF   DIV9
            MOVF    DIST_TRIP_L,W
            MOVWF   DIV10
            CLRF    DIV11
            CALL    DIV_000
;
            MOVF    DIV10,W
            CALL    ASCII_Z1
            MOVLW   ':'
            CALL    SEND_CHAR
            MOVF    DIV11,W
            MOVWF   DIV3
            MOVF    DIV12,W
            MOVWF   DIV4
            CLRF    DIV11
            MOVLW   0x60
            MOVWF   DIV12
            CALL    MULT0
;
            MOVF    DIV8,W
            CALL    ASCII
            MOVLW   ':'
            CALL    SEND_CHAR
            MOVF    DIV9,W
            MOVWF   DIV3
            MOVF    DIV10,W
            MOVWF   DIV4
            CALL    MULT
;
            MOVF    DIV8,W
            GOTO    ASCII         ; Return
;
CHK_FUNC34  MOVF    MOD_TMP_H, W
            CALL    ASCII
            SWAPF   MOD_TMP_L, W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    MOD_TMP_L, W
            BRA     CHK_FUNC35
;
CHK_FUNC40  MOVLW   0x81          ; voltage
            MOVWF   ADCON0        ; Fosc/32, channel 0, A/D on
;
            MOVLW   0x21          ; acquisition time delay 50us
            MOVWF   CNT1
LOOP        DECFSZ  CNT1, F
            BRA     LOOP
;
            BSF     ADCON0,2      ; start conv
LOOP1       BTFSC   ADCON0,2
            BRA     LOOP1
;
            BCF     PIR1,6        ; clr int
            MOVF    ADRESH, W
            BCF     ADCON0,0      ; turn A/D off
;
            MOVWF   DIV11
            CALL    HEX_DEC       ; convert to decimal
;
            MOVF    DIV7,W
            CALL    HEX_A_Z
            SWAPF   DIV8,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV8,W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'v'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC50  SWAPF   FUEL0, W      ; fuel 0 -> 5
            CALL    HEX_A_Z
            MOVF    FUEL1, W
            CALL    ASCII_ZC
            SWAPF   FUEL2, W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL2, W
            CALL    HEX_A
;
            SWAPF   FUEL3, W
            CALL    HEX_A
;
CHK_FUNC51  MOVLW   'L'
            CALL    SEND_CHAR
;
            CALL    CLR_CHAR
            MOVF    DIST_F_1, W
            CALL    ASCII_Z2
            MOVF    DIST_F_2, W
            CALL    ASCII_ZC
            SWAPF   DIST_F_3, W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIST_F_3, W
            CALL    HEX_A
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            BTFSS   MODE1,0       ; car moved - L/100km
            BRA     CHK_FUNC52
            CALL    L_100
;
            MOVF    DIV11,W
            CALL    ASCII_Z1
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV12,W
            CALL    ASCII

            MOVLW   'L'
            CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   '1'
            CALL    SEND_CHAR
            MOVLW   '0'
            CALL    SEND_CHAR
            MOVLW   '0'
            CALL    SEND_CHAR
            BRA     CHK_FUNC53
;
CHK_FUNC52  CLRF    DIV1
            MOVF    FUEL_U_1,W
            MOVWF   DIV2
            MOVF    FUEL_U_2,W
            MOVWF   DIV3
            MOVF    FUEL_U_3,W
            MOVWF   DIV4
            MOVLW   0x36          ; Litres per hour
            MOVWF   DIV11
            CLRF    DIV12
            CALL    MULT
;
            MOVF    DIV6,W
            CALL    HEX_A_Z
            SWAPF   DIV7,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV7,W
            CALL    HEX_A
            SWAPF   DIV8,W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'L'
            CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'H'
            CALL    SEND_CHAR
            MOVLW   'R'
            CALL    SEND_CHAR
;
CHK_FUNC53  CALL    CLR_CHAR
            BTFSC   FUNC1,2       ; dist cal mode
            GOTO    DISP_FUNC
;
            CALL    AVG_L_100     ; avg L/100
            MOVF    DIV11,W
            CALL    ASCII_Z1
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV12,W
            CALL    ASCII
            GOTO    DISP_FUNC
;
CHK_FUNC60  MOVF    KM_H_H,W      ; KM/Hr
            CALL    ASCII_Z2
            SWAPF   KM_H_L,W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'k'
            CALL    SEND_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'h'
            CALL    SEND_CHAR
;
            MOVLW   0x8B          ; pos display
            CALL    SEND_INS
;
            CALL    AVG_SPD       ; avg speed
            MOVF    DIV11,W
            CALL    ASCII_Z2
            SWAPF   DIV12,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV12,W
            CALL    HEX_A
;
            CALL    CYCLE_DEC     ; RPM
            MOVLW   0x12
            MOVWF   DIV9
            CLRF    DIV10
            CLRF    DIV11
            CALL    DIV_000
            MOVLW   0x01
            CALL    DIV_CONT
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            MOVF    DIV11,W
            CALL    ASCII_Z2
            MOVF    DIV12,W
            CALL    ASCII_Z0
;
            CALL    CLR_CHAR
            MOVLW   'r'
            CALL    SEND_CHAR
            MOVLW   'p'
            CALL    SEND_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
;
            MOVLW   0x99
            SUBWF   O_SPEED_H,W
            BTFSS   STATUS,Z
            BRA     CHK_FUNC61
;
            MOVLW   0x99
            SUBWF   O_SPEED_L,W
            BTFSC   STATUS,Z
            BRA     CHK_FUNC62
;
CHK_FUNC61  MOVLW   0xCD          ; pos display
            CALL    SEND_INS
;
            MOVF    O_SPEED_H,W
            CALL    ASCII_Z2
            SWAPF   O_SPEED_L,W
            CALL    HEX_A
            GOTO    DISP_FUNC
;
CHK_FUNC62  CALL    CLR_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC70  MOVF    O_SPEED_H,W   ; over speed
            CALL    ASCII_Z2
            SWAPF   O_SPEED_L,W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'O'
            CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'S'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC80  CLRF    DIV3          ; fuel latch
            MOVF    RPM_L,W
            MOVWF   DIV4
;
            MOVF    FUEL_L_1,W
            MOVWF   DIV9
            MOVF    FUEL_L_2,W
            MOVWF   DIV10
            MOVF    FUEL_L_3,W
            MOVWF   DIV11
            CALL    DIV_00
;
            MOVF    DIV9,W
            MOVWF   TEMP1
            CALL    ASCII_Z2
            MOVF    DIV10,W
            MOVWF   TEMP2
            SWAPF   DIV10,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV10,W
            CALL    HEX_A
            MOVF    DIV11,W
            MOVWF   TEMP3
            CALL    ASCII
;
            CALL    CLR_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
            MOVLW   's'
            CALL    SEND_CHAR
;
            MOVLW   0x8C          ; pos display
            CALL    SEND_INS
            CALL    CYCLE_DEC
;
            MOVF    TEMP1,W
            MOVWF   DIV9
            MOVF    TEMP2,W
            MOVWF   DIV10
            MOVF    TEMP3,W
            MOVWF   DIV11
            CALL    DIV_000
;
            MOVF    DIV11,W
            CALL    HEX_A_Z
            MOVF    DIV12,W
            CALL    ASCII_Z0
            MOVLW   '%'
            CALL    SEND_CHAR
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            MOVF    FUEL_U_1, W
            CALL    ASCII_Z1
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL_U_2, W
            CALL    ASCII
            MOVF    FUEL_U_3, W
            CALL    ASCII
;
            CALL    CLR_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
            MOVLW   'l'
            CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   's'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC90  MOVF    FUNC,W
            ANDLW   0x0F
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     CHK_FUNC900
            BRA     CHK_FUNC91
            BRA     CHK_FUNC92
            BRA     CHK_FUNC93
            BRA     CHK_FUNC94
            BRA     CHK_FUNC95
            BRA     CHK_FUNC96
            BRA     CHK_FUNC97
            BRA     CHK_FUNC98  ; DISP_FUNC
            BRA     CHK_FUNC98
;
CHK_FUNC900 MOVLW   'M'           ; cost/L
            BTFSC   BITS_BYTE,2
            MOVLW   'N'
            CALL    SEND_CHAR
            CALL    CLR_CHAR
;
            MOVLW   '$'
            CALL    SEND_CHAR
;
            BTFSS   BITS_BYTE,7
            BRA     CHK_FUNC901
            SWAPF   MSD,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    MSD,W
            CALL    HEX_A
            MOVF    LSD,W
            CALL    ASCII
            CALL    CLR_CHAR
;
            MOVF    FUEL_MOD_H,W
            CALL    ASCII
            SWAPF   FUEL_MOD_L,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL_MOD_L,W
            CALL    HEX_A
            MOVF    FUEL_TANK_100,W
            CALL    HEX_A
            BRA     CHK_FUNC902
;
CHK_FUNC901 SWAPF   COST_H,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    COST_H,W
            CALL    HEX_A
            MOVF    COST_L,W
            CALL    ASCII
            CALL    CLR_CHAR
;
            MOVF    FUEL_TANK_H,W
            CALL    ASCII_Z2
            SWAPF   FUEL_TANK_L,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL_TANK_L,W
            CALL    HEX_A
            SWAPF   FUEL_TANK_100,W
            CALL    HEX_A
;
CHK_FUNC902 MOVLW   'L'
            CALL    SEND_CHAR
;
            MOVLW   0xC0            ; pos display - range/tank
            CALL    SEND_INS
;
            BTFSC   FUNC1,2         ; dist cal mode
            GOTO    DISP_FUNC
;
            BTFSC   MODE1,0         ; car moved
            BRA     CHK_FUNC903
            MOVLW   'R'
            CALL    SEND_CHAR
            MOVLW   'A'
            CALL    SEND_CHAR
            MOVLW   'N'
            CALL    SEND_CHAR
            MOVLW   'G'
            CALL    SEND_CHAR
            MOVLW   'E'
            CALL    SEND_CHAR
            CALL    CLR_CHAR
            CALL    CLR_CHAR
            BRA     CHK_FUNC904
;
CHK_FUNC903 BCF     MODE1,0   
            CALL    L_100
            CALL    CHK_FUNC905
;
CHK_FUNC904 CALL    AVG_L_100
            CALL    CHK_FUNC905
            MOVLW   'k'
            CALL    SEND_CHAR
            MOVLW   'm'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC905 CLRF    DIV5             ; 00xxx.xx0 remove reserve from fuel tank
            MOVF    FUEL_TANK_H,W
            MOVWF   DIV6
            MOVF    FUEL_TANK_L,W
            MOVWF   DIV7
            MOVF    FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   DIV8
            CLRF    DIV1
            SWAPF   FUEL_RES,W
            ANDLW   0x0F
            MOVWF   DIV2
            SWAPF   FUEL_RES,W
            ANDLW   0xF0
            MOVWF   DIV3
            CLRF    DIV4
            CALL    DIV_6        ; SUB
            CALL    DIV_7
            BTFSC   STATUS,C     ; C=0 on negative result
            BRA     CHK_FUNC906
            CLRF    DIV10
            CLRF    DIV11
            CLRF    DIV12
            BRA     CHK_FUNC907
;
CHK_FUNC906 MOVF    DIV6,W
            MOVWF   DIV9
            MOVF    DIV7,W
            MOVWF   DIV10
            MOVF    DIV11,W
            MOVWF   DIV3
            MOVF    DIV8,W
            MOVWF   DIV11
            MOVF    DIV12,W
            MOVWF   DIV4
            CALL    DIV_00
;
CHK_FUNC907 MOVF    DIV10,W
            CALL    HEX_A_Z
            MOVF    DIV11,W
            CALL    ASCII_ZC
            SWAPF   DIV12,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV12,W
            CALL    HEX_A
            GOTO    CLR_CHAR      ; Return
;
CHK_FUNC91  MOVF    FUEL_MOD_H,W  ; fuel cal
            CALL    ASCII
            SWAPF   FUEL_MOD_L,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL_MOD_L,W
            CALL    HEX_A
            MOVF    FUEL_TANK_100,W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'L'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC92  MOVF    FUEL_CAL_H, W ; fuel cal
            CALL    ASCII
            MOVF    FUEL_CAL_L, W
            CALL    ASCII
            BRA     CHK_FUNC930
;
CHK_FUNC93  MOVLW   'N'           ; fuel cal yes or no
            BTFSC   FUNC1,1
            MOVLW   'Y'
            CALL    SEND_CHAR
CHK_FUNC930 CALL    CLR_CHAR
            MOVLW   'F'
CHK_FUNC931 CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'C'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC94  MOVF    FUEL_MOD_H,W  ; dist cal
            CALL    ASCII
            SWAPF   FUEL_MOD_L,W
            CALL    HEX_A
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    FUEL_MOD_L,W
            CALL    HEX_A
;
            CALL    CLR_CHAR
            MOVLW   'D'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC95  MOVF    DIST_CAL_H, W ; dist cal
            CALL    ASCII
            MOVF    DIST_CAL_L, W
            CALL    ASCII
            BRA     CHK_FUNC960
;
CHK_FUNC96  MOVLW   'N'           ; dist cal yes or no
            BTFSC   FUNC1,2
            MOVLW   'Y'
            CALL    SEND_CHAR
CHK_FUNC960 CALL    CLR_CHAR
            MOVLW   'D'
            GOTO    CHK_FUNC931
;
CHK_FUNC97  MOVF    FUEL_RES,W      ; fuel unuseable/reserve
            CALL    ASCII
            CALL    CLR_CHAR
            MOVLW   'F'
            CALL    SEND_CHAR
            MOVLW   '/'
            CALL    SEND_CHAR
            MOVLW   'R'
            CALL    SEND_CHAR
            GOTO    DISP_FUNC
;
CHK_FUNC98  MOVF    FUNC,W
            ANDLW   0xF0
            MOVWF   FUNC
            BRA     CHK_FUNC90
;
CYCLE_DEC   MOVF    CYCLE1,W
            MOVWF   DIV9
            MOVF    CYCLE2,W
            MOVWF   DIV10
            MOVF    CYCLE3,W
            MOVWF   DIV11
            CALL    HEX_DEC1
;
            MOVF    DIV5,W
            MOVWF   DIV9
            MOVF    DIV6,W
            MOVWF   DIV10
            MOVF    DIV7,W
            MOVWF   DIV11
            MOVF    DIV8,W
            MOVWF   DIV12
            CLRF    DIV1
            CLRF    DIV2
            CLRF    DIV3
            MOVF    CYCLE_CNT_L,W
            MOVWF   DIV4
            CALL    DIV_0000
;
            MOVF    DIV9,W
            MOVWF   DIV1
            MOVF    DIV10,W
            MOVWF   DIV2
            MOVF    DIV11,W
            MOVWF   DIV3
            MOVF    DIV12,W
            MOVWF   DIV4
            RETURN
;
AVG_SPD     CLRF    DIV3
            MOVLW   0x60
            MOVWF   DIV4
            MOVF    SEC,W
            MOVWF   DIV9
            CLRF    DIV10
            CALL    DIV_0
;
            MOVF    MIN,W
            MOVWF   DIV9
            CALL    DIV_000
;
            CLRF    DIV1
            MOVF    HRS_H, W
            MOVWF   DIV2
            MOVF    HRS,W
            MOVWF   DIV3
            MOVF    DIV10,W
            MOVWF   DIV4
            MOVF    DIST_T_1,W
            MOVWF   DIV9
            MOVF    DIST_T_2,W
            MOVWF   DIV10
            MOVF    DIST_T_3,W
            MOVWF   DIV11
            GOTO    DIV_000       ; return to calling prog
;
AVG_L_100   MOVF    FUEL0,W
            MOVWF   DIV9
            MOVF    FUEL1,W
            MOVWF   DIV10
            MOVF    FUEL2,W
            MOVWF   DIV11
            MOVF    FUEL3,W
            ANDLW   0xF0
            MOVWF   DIV12
            CLRF    DIV1
            MOVF    DIST_F_1,W
            MOVWF   DIV2
            MOVF    DIST_F_2,W
            MOVWF   DIV3
            MOVF    DIST_F_3,W
            MOVWF   DIV4
            CALL    DIV_0000
;
            MOVLW   0x02          ; move 2 more times
            MOVWF   CNT1
            GOTO    DIV_40        ; return to calling prog
;
CHK_KEY     MOVF    KEY_DELAY,W
            BTFSS   STATUS,Z
            BRA     CHK_KEY0
;
            MOVF    PORTA,W
            ANDLW   0x2E
            MOVWF   KEY
            SUBLW   0x2E
            BTFSC   STATUS,Z
            BRA     NO_KEY
;
KEY_RTN     BTFSC   BITS_BYTE,5
            BRA     KEY_D
;
            BSF     BITS_BYTE,5    ; is key still pressed
            BSF     BITS_BYTE,4    ; key pressed
            MOVLW   0x0A           ; beep for 40ms when key pressed
            MOVWF   BEEP_DELAY
            BCF     PORTA,4        ; enable beep
            BRA     KEY_D
;
NO_KEY      BCF     BITS_BYTE,5    ; no key pressed
;
KEY_D       MOVLW   0x06           ; 24ms delay
            MOVWF   KEY_DELAY
;
CHK_KEY0    BTFSS   BITS_BYTE,4
            GOTO    SEC1
            BCF     BITS_BYTE,4
;
            MOVF    KEY, W       ; clear key
            SUBLW   0x0E
            BTFSS   STATUS, Z
            BRA     CHK_KEY3
;
CLEAR       CLRF    FUNC
;
CLEAR_0     BCF     BITS_BYTE,6
;
CLEAR_1     BCF     BITS_BYTE,7
            MOVLW   0x0C    ; D-on , C-off, B-off
            CALL    SEND_INS
            GOTO    CHK_FUNC
;
CLEAR_2     BCF     BITS_BYTE,7
            MOVLW   0x0C    ; D-on , C-off, B-off
            CALL    SEND_INS
            GOTO    CHK_F
;
CHK_KEY3    BTFSS   BITS_BYTE,7      ; mod flag
            GOTO    CHK_KEY2
;
            SWAPF   FUNC,W
            ANDLW   0x0F
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD00_1
            BRA     MOD10_1
            BRA     MOD20
            BRA     MOD30
            BRA     SEC1
            BRA     MOD50
            BRA     MOD60_0
            BRA     MOD70_0
            BRA     SEC1
            BRA     MOD90_0
;
MOD00_1     MOVLW   0x80         ; dist trip
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD00_2
            NOP                  ; skip .
            BRA     MOD00_3
            NOP                  ; skip
            BRA     MOD00_4
            NOP                  ; skip
            NOP                  ; skip $
            BRA     MOD00_5
            BRA     MOD00_6
            BRA     MOD00_7
            BRA     MOD00_8
            NOP                  ; skip .
            BRA     MOD00_9
            BRA     MOD00_A
;
MOD00_2     SWAPF   FUEL_MULT,W
            CALL    ENT_KEY_H
            MOVWF   FUEL_MULT
            CALL    CHAR_SKIP    ; .
            GOTO    CHK_FUNC
;
MOD00_3     MOVF    FUEL_MULT,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_MULT
            CALL    CHAR_SKIP    ; space
            GOTO    CHK_FUNC
;
MOD00_4     MOVF    NO_PEOPLE,W
            CALL    ENT_KEY_L
            ANDLW   0x0F
            MOVWF   NO_PEOPLE
            CALL    CHAR_SKIP    ; space
            CALL    CHAR_SKIP    ; $
            GOTO    CHK_FUNC
;
MOD00_5     SWAPF   TOLL1,W
            CALL    ENT_KEY_H
            MOVWF   TOLL1
            GOTO    CHK_FUNC
;
MOD00_6     MOVF    TOLL1,W
            CALL    ENT_KEY_L
            MOVWF   TOLL1
            GOTO    CHK_FUNC
;
MOD00_7     SWAPF   TOLL2,W
            CALL    ENT_KEY_H
            MOVWF   TOLL2
            GOTO    CHK_FUNC
;
MOD00_8     MOVF    TOLL2,W
            CALL    ENT_KEY_L
            MOVWF   TOLL2
            CALL    CHAR_SKIP    ; .
            GOTO    CHK_FUNC
;
MOD00_9     SWAPF   TOLL3,W
            CALL    ENT_KEY_H
            MOVWF   TOLL3
            GOTO    CHK_FUNC
;
MOD00_A     MOVF    TOLL3,W
            CALL    ENT_KEY_L
            MOVWF   TOLL3
;
            MOVF    KEY, W
            SUBLW   0x26           ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
;
MOD00_Z     CALL    SAVE_VAL0
            GOTO    CLEAR_0
;
MOD10_1     MOVLW   0x80         ; cost/km
            SUBWF   CNT4,W
            BTFSS   STATUS,Z
            BRA     MOD10_2
            SWAPF   COST_KM,W
            CALL    ENT_KEY_H
            MOVWF   COST_KM
            GOTO    CHK_FUNC
;
MOD10_2     MOVF    COST_KM,W
            CALL    ENT_KEY_L
            MOVWF   COST_KM
;
            MOVF    KEY, W
            SUBLW   0x26         ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
            BRA     MOD00_Z      ; save
;
MOD20       CLRF    DIST_H       ; clr dist and time
            CLRF    DIST_L
            CLRF    DIST_T_1
            CLRF    DIST_T_2
            CLRF    DIST_T_3
;
            CLRF    HRS_H
            CLRF    HRS
            CLRF    MIN
            CLRF    SEC
            CLRF    UPDATE1
            GOTO    CLEAR_0
;
MOD30       MOVLW   0x80         ; dist trip
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD30_1
            BRA     MOD30_2
            BRA     MOD30_3
            NOP                  ; skip
            BRA     MOD30_5
;
MOD30_1     SWAPF   MOD_TMP_H,W
            CALL    ENT_KEY_H
            MOVWF   MOD_TMP_H
            GOTO    CHK_FUNC
;
MOD30_2     MOVF    MOD_TMP_H,W
            CALL    ENT_KEY_L
            MOVWF   MOD_TMP_H
            GOTO    CHK_FUNC
;
MOD30_3     SWAPF   MOD_TMP_L,W
            CALL    ENT_KEY_H
            MOVWF   MOD_TMP_L
            CALL    CHAR_SKIP
            GOTO    CHK_FUNC
;
MOD30_5     MOVF    MOD_TMP_L,W
            CALL    ENT_KEY_L
            MOVWF   MOD_TMP_L
;
            MOVF    KEY, W
            SUBLW   0x26         ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
;
            MOVF    DIST_TRIP_L,W
            BTFSS   STATUS,Z
            BRA     MOD30_6
            MOVF    MOD_TMP_L,W
            MOVWF   DIST_TRIP_L
            MOVF    MOD_TMP_H,W
            MOVWF   DIST_TRIP_H
            GOTO    CLEAR_0
;
MOD30_6     MOVLW   0x99
            MOVWF   DIV1
            MOVWF   DIV2
            MOVWF   DIV3
            MOVF    DIST_TRIP_L,W
            MOVWF   DIV4
;
            CLRF    DIV5
            CLRF    DIV6
            MOVF    MOD_TMP_H,W
            MOVWF   DIV7
            MOVF    MOD_TMP_L,W
            MOVWF   DIV8
            CALL    DIV_7        ; add
            MOVF    DIV7,W
            MOVWF   DIST_TRIP_H
            MOVF    DIV8,W
            MOVWF   DIST_TRIP_L
            GOTO    CLEAR_0
;
MOD50       CLRF    FUEL0         ; clr fuel total
            CLRF    FUEL1
            CLRF    FUEL2
            MOVF    FUEL3,W
            ANDLW   0x0F
            MOVWF   FUEL3
            CLRF    COST_TRIP_0
            CLRF    COST_TRIP_1
            CLRF    COST_TRIP_2
            CLRF    COST_TRIP_3
            CLRF    COST_TRIP_4
            CLRF    DIST_F_1
            CLRF    DIST_F_2
            CLRF    DIST_F_3
            GOTO    CLEAR_0
;
MOD60_0     CLRF    DIV1         ; speed + 4
            CLRF    DIV2
            MOVF    KM_H_H,W
            MOVWF   DIV3
            MOVF    KM_H_L,W
            MOVWF   DIV4
            CLRF    DIV5
            CLRF    DIV6
            CLRF    DIV7
            MOVLW   0x40
            MOVWF   DIV8
            CALL    DIV_7        ; add
;
            MOVF    DIV7,W
            MOVWF   O_SPEED_H
            MOVF    DIV8,W
            MOVWF   O_SPEED_L
            GOTO    CLEAR_0      ; saved on power down
;
MOD70_0     MOVLW   0x99         ; clr over speed
            MOVWF   O_SPEED_H
            MOVWF   O_SPEED_L
            GOTO    CLEAR_0      ; saved on power down
;
MOD90_0     MOVF    FUNC, W
            SUBLW   0x90         ; cost/L
            BTFSS   STATUS, Z
            GOTO    MOD91_0
;
            MOVLW   0x80
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD90_1
            NOP                  ; skip space
            NOP                  ; skip $
            BRA     MOD90_3
            NOP                  ; skip .
            BRA     MOD90_5
            BRA     MOD90_6
            BRA     MOD90_7
            NOP                  ; skip space
            BRA     MOD90_9
            BRA     MOD90_A
            BRA     MOD90_B
            NOP                  ; skip .
            BRA     MOD90_D
            BRA     MOD90_D0
;
MOD90_1     BTFSS   BITS_BYTE,2
            BRA     MOD90_10
            MOVF    FUEL_TANK_H,W
            MOVWF   FUEL_MOD_H
            MOVF    FUEL_TANK_L,W
            MOVWF   FUEL_MOD_L
            MOVLW   0xF0
            ANDWF   FUEL_TANK_100,F
            SWAPF   FUEL_TANK_100,W
            IORWF   FUEL_TANK_100,F
            BRA     MOD90_11
;
MOD90_10    CLRF    FUEL_MOD_H
            CLRF    FUEL_MOD_L
            MOVF    FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   FUEL_TANK_100
;
MOD90_11    MOVF    KEY, W
            SUBLW   0x2C
            BTFSS   STATUS, Z    ; up key
            BRA     MOD90_13     ; enter key
;
            BTFSS   BITS_BYTE,2
            BRA     MOD90_12
            BCF     BITS_BYTE,2  ; mod mode
            GOTO    CHK_FUNC
;
MOD90_12    BSF     BITS_BYTE,2  ; new mode
            GOTO    CHK_FUNC
;
MOD90_13    CALL    CHAR_SKIP    ; if mode/enter key pressed
            CALL    CHAR_SKIP    ; skip space
            CALL    CHAR_SKIP    ; skip $
            GOTO    CHK_FUNC
;
MOD90_3     SWAPF   MSD,W
            CALL    ENT_KEY_H
            MOVWF   MSD
            CALL    CHAR_SKIP    ; skip .
            GOTO    CHK_FUNC
;
MOD90_5     MOVF    MSD,W
            CALL    ENT_KEY_L
            MOVWF   MSD
            GOTO    CHK_FUNC
;
MOD90_6     SWAPF   LSD,W
            CALL    ENT_KEY_H
            MOVWF   LSD
            GOTO    CHK_FUNC
;
MOD90_7     MOVF    LSD,W
            CALL    ENT_KEY_L
            MOVWF   LSD
            CALL    CHAR_SKIP    ; skip space
            GOTO    CHK_FUNC
;
MOD90_9     SWAPF   FUEL_MOD_H,W
            CALL    ENT_KEY_H
            MOVWF   FUEL_MOD_H
            GOTO    CHK_FUNC
;
MOD90_A     MOVF    FUEL_MOD_H,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_MOD_H
            GOTO    CHK_FUNC
;
MOD90_B     SWAPF   FUEL_MOD_L,W
            CALL    ENT_KEY_H
            MOVWF   FUEL_MOD_L
            CALL    CHAR_SKIP       ; skip .
            GOTO    CHK_FUNC
;
MOD90_D     MOVF    FUEL_MOD_L,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_MOD_L
            GOTO    CHK_FUNC
;
MOD90_D0    MOVF    FUEL_TANK_100,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_TANK_100
;
            MOVF    KEY, W
            SUBLW   0x26           ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
;
MOD90_E     BTFSS   BITS_BYTE,2
            BRA     MOD90_F
            MOVF    FUEL_MOD_H,W
            MOVWF   FUEL_TANK_H
            MOVF    FUEL_MOD_L,W
            MOVWF   FUEL_TANK_L
            SWAPF   FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   FUEL_TANK_100
            MOVF    MSD,W
            MOVWF   COST_H
            MOVF    LSD,W
            MOVWF   COST_L
            BCF     BITS_BYTE,2
            GOTO    MOD00_Z         ; save
;
MOD90_F     CLRF    DIV1
            MOVF    FUEL_TANK_H,W
            MOVWF   DIV2
            MOVF    FUEL_TANK_L,W
            MOVWF   DIV3
            MOVF    FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   DIV4
            MOVF    COST_H,W           ; old cost
            MOVWF   DIV11
            MOVF    COST_L,W           ; old cost
            MOVWF   DIV12
            CALL    MULT
;
            MOVF    DIV6,W
            MOVWF   TEMP1
            MOVF    DIV7,W
            MOVWF   TEMP2
            MOVF    DIV8,W
            MOVWF   TEMP3
;
            CLRF    DIV1
            MOVF    FUEL_MOD_H,W
            MOVWF   DIV2
            MOVF    FUEL_MOD_L,W
            MOVWF   DIV3
            SWAPF   FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   DIV4
            MOVF    MSD,W              ; new cost
            MOVWF   DIV11
            MOVF    LSD,W              ; new cost
            MOVWF   DIV12
            CALL    MULT
;
            CLRF    DIV1
            MOVF    TEMP1,W
            MOVWF   DIV2
            MOVF    TEMP2,W
            MOVWF   DIV3
            MOVF    TEMP3,W
            MOVWF   DIV4
;
            CLRF    DIV5
            CALL    DIV_7         ; add
;
            MOVF    DIV6,W
            MOVWF   DIV9
            MOVF    DIV7,W
            MOVWF   DIV10
            MOVF    DIV8,W
            MOVWF   DIV11
;
            CLRF    DIV1
            MOVF    FUEL_TANK_H,W
            MOVWF   DIV2
            MOVF    FUEL_TANK_L,W
            MOVWF   DIV3
            MOVF    FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   DIV4
;
            CLRF    DIV5
            MOVF    FUEL_MOD_H,W
            MOVWF   DIV6
            MOVF    FUEL_MOD_L,W
            MOVWF   DIV7
            SWAPF   FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   DIV8
            CALL    DIV_7         ; add
;
            CLRF    DIV1
            MOVF    DIV6,W
            MOVWF   FUEL_TANK_H
            MOVWF   DIV2
            MOVF    DIV7,W
            MOVWF   FUEL_TANK_L
            MOVWF   DIV3
            MOVF    DIV8,W
            ANDLW   0xF0
            MOVWF   FUEL_TANK_100
            MOVWF   DIV4
            CALL    DIV_000
            MOVLW   0x02
            CALL    DIV_CONT
;
            MOVF    DIV11,W
            MOVWF   COST_H        ; new calc cost
            MOVF    DIV12,W
            MOVWF   COST_L
            GOTO    MOD00_Z      ; save
;
MOD91_0     MOVF    FUNC, W
            SUBLW   0x91          ; fuel cal
            BTFSS   STATUS, Z
            GOTO    MOD92_0
;
            MOVLW   0x80
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD90_9
            BRA     MOD90_A
            BRA     MOD90_B
            NOP                   ; skip .
            BRA     MOD90_D
            BRA     MOD91_5
;
MOD91_5     MOVF    FUEL_TANK_100,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_TANK_100
;
            MOVF    KEY, W
            SUBLW   0x26           ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
;
MOD91_6     MOVF    FUEL0,W
            MOVWF   DIV1
            MOVF    FUEL1,W
            MOVWF   DIV2
            MOVF    FUEL2,W
            MOVWF   DIV3
            MOVF    FUEL3,W
            ANDLW   0xF0
            MOVWF   DIV4
;
            MOVF    FUEL_MOD_H,W
            MOVWF   DIV9
            MOVF    FUEL_MOD_L,W
            MOVWF   DIV10
            SWAPF   FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   DIV11
            CALL    DIV_000
;
            MOVLW   0x02
            CALL    DIV_CONT
;
            MOVF    DIV9,W
            MOVWF   DIV1
            MOVF    DIV10,W
            MOVWF   DIV2
            MOVF    DIV11,W
            MOVWF   DIV3
            MOVF    DIV12,W
            MOVWF   DIV4
            MOVF    FUEL_CAL_H,W
            MOVWF   DIV11
            MOVF    FUEL_CAL_L,W
            MOVWF   DIV12
            CALL    MULT
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            MOVF    DIV7,W
            CALL    ASCII
            MOVF    DIV8,W
            CALL    ASCII
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV9,W
            CALL    ASCII
            GOTO    CLEAR_2
;
MOD92_0     MOVF    FUNC, W
            SUBLW   0x92         ; fuel cal value
            BTFSS   STATUS, Z
            BRA     MOD93_0
;
            MOVLW   0x80
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD92_1
            BRA     MOD92_2
            BRA     MOD92_3
            BRA     MOD92_4
;
MOD92_1     SWAPF   FUEL_CAL_H,W
            CALL    ENT_KEY_H
            MOVWF   FUEL_CAL_H
            GOTO    CHK_FUNC
;
MOD92_2     MOVF    FUEL_CAL_H,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_CAL_H
            GOTO    CHK_FUNC
;
MOD92_3     SWAPF   FUEL_CAL_L,W
            CALL    ENT_KEY_H
            MOVWF   FUEL_CAL_L
            GOTO    CHK_FUNC
;
MOD92_4     MOVF    FUEL_CAL_L,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_CAL_L
;
MOD92_5     MOVF    KEY, W
            SUBLW   0x26           ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
            BRA     MOD93_3      ; save
;
MOD93_0     MOVF    FUNC, W
            SUBLW   0x93         ; fuel cal, yes or no
            BTFSS   STATUS, Z
            BRA     MOD94_0
;
            MOVF    KEY, W
            SUBLW   0x2C
            BTFSS   STATUS, Z    ; up key
            GOTO    SEC1
;
            BTFSS   FUNC1,1      ; fuel cal flag
            BRA     MOD93_1
            BCF     FUNC1,1
            BRA     MOD93_3
;
MOD93_1     BSF     FUNC1,1      ; fuel cal on
MOD93_2     CLRF    FUEL0
            CLRF    FUEL1
            CLRF    FUEL2
            CLRF    FUEL3
            CLRF    FUEL4
            CLRF    FUEL5
            CLRF    COST_TRIP_0
            CLRF    COST_TRIP_1
            CLRF    COST_TRIP_2
            CLRF    COST_TRIP_3
            CLRF    COST_TRIP_4
            CLRF    DIST_F_1
            CLRF    DIST_F_2
            CLRF    DIST_F_3
;
MOD93_3     CALL    SAVE_VAL0
            GOTO    CLEAR_1
;
MOD94_0     MOVF    FUNC, W
            SUBLW   0x94         ; dist cal
            BTFSS   STATUS, Z
            BRA     MOD95_0
;
            MOVLW   0x80
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD90_9
            BRA     MOD90_A
            BRA     MOD90_B
            NOP                  ; skip .
            BRA     MOD94_1
;
MOD94_1     MOVF    FUEL_MOD_L,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_MOD_L
;
            MOVF    KEY, W
            SUBLW   0x26           ; mode/enter key
            BTFSS   STATUS, Z
            GOTO    CHK_FUNC
;
            MOVF    FUEL_MOD_H,W
            MOVWF   DIV3
            MOVF    FUEL_MOD_L,W
            MOVWF   DIV4
            MOVF    DIST_T_1, W
            MOVWF   DIV9
            MOVF    DIST_H,W
            MOVWF   DIV10
            MOVF    DIST_L,W
            MOVWF   DIV11
            CALL    DIV_00
;
            MOVLW   0xC0          ; pos display
            CALL    SEND_INS
            MOVF    DIV10,W
            CALL    ASCII
            MOVF    DIV11,W
            CALL    ASCII
            MOVLW   '.'
            CALL    SEND_CHAR
            MOVF    DIV12,W
            CALL    ASCII
            GOTO    CLEAR_2
;
MOD95_0     MOVF    FUNC, W
            SUBLW   0x95         ; dist cal value
            BTFSS   STATUS, Z
            BRA     MOD96_0
;
            MOVLW   0x80
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD95_1
            BRA     MOD95_2
            BRA     MOD95_3
            BRA     MOD95_4
;
MOD95_1     SWAPF   DIST_CAL_H,W
            CALL    ENT_KEY_H
            MOVWF   DIST_CAL_H
            GOTO    CHK_FUNC
;
MOD95_2     MOVF    DIST_CAL_H,W
            CALL    ENT_KEY_L
            MOVWF   DIST_CAL_H
            GOTO    CHK_FUNC
;
MOD95_3     SWAPF   DIST_CAL_L,W
            CALL    ENT_KEY_H
            MOVWF   DIST_CAL_L
            GOTO    CHK_FUNC
;
MOD95_4     MOVF    DIST_CAL_L,W
            CALL    ENT_KEY_L
            MOVWF   DIST_CAL_L
            GOTO    MOD92_5
;
MOD96_0     MOVF    FUNC, W
            SUBLW   0x96         ; dist cal, yes or no
            BTFSS   STATUS, Z
            BRA     MOD97_0
;
            MOVF    KEY, W
            SUBLW   0x2C
            BTFSS   STATUS, Z    ; up key
            GOTO    SEC1
;
            BTFSS   FUNC1,2      ; dist cal flag
            BRA     MOD96_1
            BCF     FUNC1,2
            BRA     MOD96_2
;
MOD96_1     BSF     FUNC1,2      ; dist cal on
MOD96_2     CLRF    DIST_L
            CLRF    DIST_H
            CLRF    DIST_T_1
            GOTO    MOD93_3      ; save
;
MOD97_0     MOVF    FUNC, W
            SUBLW   0x97         ; fuel reserve OR unuseable
            BTFSS   STATUS, Z
            GOTO    SEC1
;
            MOVLW   0x80
            SUBWF   CNT4,W
            RLNCF   WREG,W      ; W = W * 2
            ADDLW   0x06        ;compensate for extra instructions
            ADDWF   PCL,W       ;PCL read to update PCLATH and PCLATU
            BTFSC   STATUS,C
            INCF    PCLATH,F
            MOVWF   PCL
            BRA     MOD97_1
            BRA     MOD97_2
;
MOD97_1     SWAPF   FUEL_RES,W
            CALL    ENT_KEY_H
            MOVWF   FUEL_RES
            GOTO    CHK_FUNC
;
MOD97_2     MOVF    FUEL_RES,W
            CALL    ENT_KEY_L
            MOVWF   FUEL_RES
            GOTO    MOD92_5
;
CHK_KEY2    BTFSS   BITS_BYTE,6
            GOTO    CHK_KEY1      ; if no entry key pressed
            MOVF    FUNC,W
            CALL    ENT_KEY_L
            MOVWF   FUNC
            GOTO    CHK_FUNC
;
CHK_KEY1    SWAPF   FUNC,W
            CALL    ENT_KEY_H
            MOVWF   FUNC
            GOTO    CHK_FUNC
;
SEC1        BTFSS   MODE1,3       ; one second yet
            GOTO    CHK_KEY       ; no
            BCF     MODE1,3
;
            BTFSS   MODE1,4       ; is motor running
            BRA     FUEL_B_D
            BCF     MODE1,4
            MOVF    SEC, W
            CALL    ADD_1
            MOVWF   SEC
            XORLW   0x60
            BTFSS   STATUS, Z
            BRA     FUEL_B_D
            CLRF    SEC
            MOVF    MIN, W
            CALL    ADD_1
            MOVWF   MIN
            XORLW   0x60
            BTFSS   STATUS, Z
            BRA     FUEL_B_D
            CLRF    MIN
            MOVF    HRS, W
            CALL    ADD_1
            MOVWF   HRS
            BTFSS   STATUS, Z
            BRA     FUEL_B_D
            MOVF    HRS_H, W
            CALL    ADD_1
            MOVWF   HRS_H
;
FUEL_B_D    MOVF    FUEL_L_1,W
            MOVWF   DIV9
            MOVF    FUEL_L_2,W
            MOVWF   DIV10
            MOVF    FUEL_L_3,W
            MOVWF   DIV11
            CALL    HEX_DEC1
;
FUEL_B_D0   MOVF    DIV6,W
            MOVWF   FUEL_L_1
            MOVWF   DIV2
            MOVF    DIV7,W
            MOVWF   FUEL_L_2
            MOVWF   DIV3
            MOVF    DIV8,W
            MOVWF   FUEL_L_3
            MOVWF   DIV4
;
            CLRF    DIV1
            MOVF    FUEL_CAL_H,W
            MOVWF   DIV11
            MOVF    FUEL_CAL_L,W
            MOVWF   DIV12
            CALL    MULT
;
            MOVF    DIV6,W
            MOVWF   FUEL_U_1
            MOVWF   DIV2
            MOVF    DIV7,W
            MOVWF   FUEL_U_2
            MOVWF   DIV3
            MOVF    DIV8,W
            MOVWF   FUEL_U_3
            MOVWF   DIV4
;
            CLRF    DIV1
;
            CLRF    DIV5
            MOVF    FUEL3,W
            ANDLW   0x0F
            MOVWF   DIV6
            MOVF    FUEL4,W
            MOVWF   DIV7
            MOVF    FUEL5,W
            MOVWF   DIV8
            CALL    DIV_7           ; add
;
            SWAPF   DIV6,W
            ANDLW   0x0F
            MOVWF   CNT1
            SWAPF   DIV5,W
            ANDLW   0xF0
            IORWF   CNT1,F
;
            MOVF    DIV7,W
            MOVWF   FUEL4
            MOVF    DIV8,W
            MOVWF   FUEL5
;
            CLRF    DIV1
            CLRF    DIV2
            MOVF    DIV5,W
            MOVWF   DIV3
            MOVF    DIV6,W
            MOVWF   DIV4
;
            MOVF    FUEL0,W
            MOVWF   DIV5
            MOVF    FUEL1,W
            MOVWF   DIV6
            MOVF    FUEL2,W
            MOVWF   DIV7
            MOVF    FUEL3,W
            ANDLW   0xF0
            MOVWF   DIV8
            CALL    DIV_7           ; add
;
            MOVF    DIV5,W
            MOVWF   FUEL0
            MOVF    DIV6,W
            MOVWF   FUEL1
            MOVF    DIV7,W
            MOVWF   FUEL2
            MOVF    DIV8,W
            MOVWF   FUEL3
;
            MOVF    CNT1,W
            BTFSC   STATUS,Z
            GOTO    DIST_TRAV      ; = 0
;
FUEL_LEFT   MOVF    FUEL_TANK_100,W
            ADDLW   0x90
            CALL    DEC_ADJ
            MOVWF   FUEL_TANK_100
            BTFSC   STATUS, C
            BRA     COST_TRIP
;
            MOVF    FUEL_TANK_L, W
            CALL    SUB_1
            MOVWF   FUEL_TANK_L
            BTFSC   STATUS, C
            BRA     COST_TRIP
;
            MOVF    FUEL_TANK_H, W
            CALL    SUB_1
            MOVWF   FUEL_TANK_H
;
COST_TRIP   CLRF    DIV1
            CLRF    DIV2
            MOVF    COST_H,W
            MOVWF   DIV3
            MOVF    COST_L,W
            MOVWF   DIV4
;
            MOVF    COST_TRIP_1,W
            MOVWF   DIV5
            MOVF    COST_TRIP_2,W
            MOVWF   DIV6
            MOVF    COST_TRIP_3,W
            MOVWF   DIV7
            MOVF    COST_TRIP_4,W
            MOVWF   DIV8
            CALL    DIV_7           ; add
;
            MOVLW   0x00
            ADDWFC  COST_TRIP_0,W
            CALL    DEC_ADJ
            MOVWF   COST_TRIP_0
;
            MOVF    DIV5,W
            MOVWF   COST_TRIP_1
            MOVF    DIV6,W
            MOVWF   COST_TRIP_2
            MOVF    DIV7,W
            MOVWF   COST_TRIP_3
            MOVF    DIV8,W
            MOVWF   COST_TRIP_4
;
            MOVF    CNT1,W
            CALL    SUB_1
            MOVWF   CNT1
            BTFSS   STATUS, Z
            BRA     FUEL_LEFT
;
DIST_TRAV   MOVF    TIMEOUT,W
            BTFSS   STATUS,Z
            BRA     DIST_TRAV0
            BTFSC   MODE1,5
            BRA     DIST_TRAV0
            BCF     MODE1,2
            CALL    SAVE_VAL1
            BCF     PORTB,2        ; power down
            BSF     MODE1,5
;
DIST_TRAV0  MOVF    DIST_L_H,W
            MOVWF   DIV9
            MOVF    DIST_L_L,W
            MOVWF   DIV10
;
            MOVF    DIST_CAL_H,W
            MOVWF   DIV3
            MOVF    DIST_CAL_L,W
            MOVWF   DIV4
            CALL    DIV_0
            MOVF    DIV11,W
            MOVWF   DIST_TRAV_H
            MOVWF   DIV3
            MOVF    DIV12,W
            MOVWF   DIST_TRAV_L
            MOVWF   DIV4
;
KM_H        CLRF    DIV11
            MOVLW   0x36
            MOVWF   DIV12
            CALL    MULT0
;
            MOVF    DIV8,W
            MOVWF   KM_H_H
            MOVWF   DIV7
            MOVF    DIV9,W
            MOVWF   KM_H_L
            MOVWF   DIV8
;
            CLRF    DIV1
            CLRF    DIV2
            MOVF    O_SPEED_H,W
            MOVWF   DIV3
            MOVF    O_SPEED_L,W
            MOVWF   DIV4
            CLRF    DIV5
            CLRF    DIV6
            CALL    DIV_6
            CALL    DIV_7
            BTFSS   STATUS,C       ; C=1 on positive result
            BRA     KM_H1
;
            BTFSC   BITS_BYTE,1
            GOTO    CHK_F
            BSF     BITS_BYTE,1    ; beep enable, over speed
            BSF     MODE1,6        ; 2 beeps
;
KM_H0       MOVLW   0x32           ; 200ms delay
            MOVWF   BEEP_DELAY
            BCF     PORTA,4        ; enable beep
            GOTO    CHK_F
;
KM_H1       BTFSS   BITS_BYTE,1
            GOTO    CHK_F
            BCF     BITS_BYTE,1
            BRA     KM_H0
;
L_100       BCF     MODE1,0
            MOVF    FUEL_U_1,W
            MOVWF   DIV9
            MOVF    FUEL_U_2,W
            MOVWF   DIV10
            MOVF    FUEL_U_3,W
            MOVWF   DIV11
            MOVF    DIST_TRAV_H,W
            MOVWF   DIV3
            MOVF    DIST_TRAV_L,W
            MOVWF   DIV4
            GOTO    DIV_00        ; return to calling prog
;
CHAR_SKIP   MOVF    KEY, W
            SUBLW   0x26          ; mode/enter key
            BTFSC   STATUS, Z
            INCF    CNT4,F
            RETURN
;
ENT_KEY_H   CALL    ENT_KEY
            SWAPF   DATA_MOD,W
            RETURN
;
ENT_KEY_L   CALL    ENT_KEY
            MOVF    DATA_MOD,W
            RETURN
;
ENT_KEY     MOVWF   DATA_MOD
            MOVF    KEY, W
            SUBLW   0x26          ; mode/enter key
            BTFSS   STATUS, Z
            BRA     UP
ENT_KEY0    BTFSC   BITS_BYTE,6
            BRA     ENT_KEY1
            BSF     BITS_BYTE,6
            RETURN
;
ENT_KEY1    BTFSS   BITS_BYTE,7
            BRA     ENT_KEY2
ENT_KEY10   INCF    CNT4,F
            RETURN
;
ENT_KEY2    BSF     BITS_BYTE,7
            MOVLW   0x80
            MOVWF   CNT4
            CALL    SEND_INS
;
INIT30      MOVF    FUNC,W
            SUBLW   0x30
            BTFSS   STATUS,Z
            BRA     INIT90
            MOVF    DIST_TRIP_H, W
            MOVWF   MOD_TMP_H
            MOVF    DIST_TRIP_L, W
            MOVWF   MOD_TMP_L
            CLRF    DIST_TRIP_L
            MOVLW   0x10
            MOVWF   DIST_TRIP_H
            BRA     BLINK
;
INIT90      MOVF    FUNC,W
            SUBLW   0x90
            BTFSS   STATUS,Z
            BRA     BLINK
            MOVF    COST_H,W
            MOVWF   MSD
            MOVF    COST_L,W
            MOVWF   LSD
;
            BTFSS   BITS_BYTE,2
            BRA     INIT90_1
            MOVF    FUEL_TANK_H,W
            MOVWF   FUEL_MOD_H
            MOVF    FUEL_TANK_L,W
            MOVWF   FUEL_MOD_L
            MOVLW   0xF0
            ANDWF   FUEL_TANK_100,F
            SWAPF   FUEL_TANK_100,W
            IORWF   FUEL_TANK_100,F
            BRA     BLINK
;
INIT90_1    CLRF    FUEL_MOD_H
            CLRF    FUEL_MOD_L
            MOVF    FUEL_TANK_100,W
            ANDLW   0xF0
            MOVWF   FUEL_TANK_100
;
BLINK       MOVLW   0x0D          ; D-on , C-off, B-on
            GOTO    SEND_INS      ; Return
;
UP          MOVF    KEY, W
            SUBLW   0x2C
            BTFSS   STATUS, Z    ; up key
            BRA     DOWN
            MOVLW   0x0F
            ANDWF   DATA_MOD,W
            SUBLW   0x09
            BTFSS   STATUS,Z
            BRA     UP_1
            MOVLW   0xF0
            ANDWF   DATA_MOD,F
            RETURN
;
UP_1        INCF    DATA_MOD,F
            RETURN
;
DOWN        MOVF    KEY, W
            SUBLW   0x2A         ; down key
            BTFSS   STATUS, Z
            RETURN
;
            MOVLW   0x0F
            ANDWF   DATA_MOD,W
            BTFSS   STATUS,Z
            BRA     DOWN_1
            MOVLW   0x09
            ADDWF   DATA_MOD,F
            RETURN
;
DOWN_1      DECF    DATA_MOD,F
            RETURN
;
SUB_1       ADDLW  0x99
            BRA    DEC_ADJ
;
ADD_1       ADDLW  0x01
;
DEC_ADJ     BTFSS  STATUS, C       ; Check carry flag
            BRA    DEC_ADJ_1
            DAW
            IORLW  0x00            ; Check zero
            BSF    STATUS,C
            RETURN
;
DEC_ADJ_1   DAW
            IORLW  0x00            ; Check zero
            RETURN
;
DIV_0       CLRF    DIV11
DIV_00      CLRF    DIV1
            CLRF    DIV2
DIV_000     CLRF    DIV12
DIV_0000    CLRF    DIV5
            CLRF    DIV6
            CLRF    DIV7
            CLRF    DIV8
;
            MOVF    DIV1,W         ; check for zero
            IORWF   DIV2,W
            IORWF   DIV3,W
            IORWF   DIV4,W
            BTFSC   STATUS,Z
            RETURN
;
DIV_OK      MOVLW   0x08           ; move 8 times
DIV_CONT    MOVWF   CNT1
            BRA     DIV_40
DIV_1       RCALL   DIV_6
DIV_2       RCALL   DIV_7
            BTFSS   STATUS,C       ; C=1 on positive result
            BRA     DIV_3          ; C=0 on negative result
            INCF    DIV12, F
            BRA     DIV_2
DIV_3       RCALL   DIV_6          ; return divisor to original value
            DECF    CNT1, F
            BTFSC   STATUS, Z
            BRA     DIV_7          ; return to original value and exit
            RCALL   DIV_7          ; return dividend to original value
;
DIV_40      MOVLW   0x04           ; shift to left 4 places
            MOVWF   CNT3
DIV_4       BCF     STATUS, C      ; move 8 numbers to left
            RLCF    DIV12,F
            RLCF    DIV11,F
            RLCF    DIV10,F
            RLCF    DIV9,F
            RLCF    DIV8,F
            RLCF    DIV7,F
            RLCF    DIV6,F
            RLCF    DIV5,F
            DECFSZ  CNT3,F
            BRA     DIV_4
            BRA     DIV_1
;
DIV_6       LFSR    FSR0,0x050
DIV_62      MOVLW   0x04           ; 99 - divisor + carry
            MOVWF   CNT3
DIV_60      MOVF    INDF0, W
            SUBLW   0x99
            MOVWF   POSTINC0
            DECFSZ  CNT3, F
            BRA     DIV_60
;
            BSF     STATUS,C     ; set carry
            MOVF    POSTDEC0,W   ; dummy read
            MOVLW   0x04
            MOVWF   CNT3
DIV_61      MOVLW   0x00
            ADDWFC  INDF0, W
            CALL    DEC_ADJ
            MOVWF   POSTDEC0
            DECFSZ  CNT3, F
            BRA     DIV_61
            RETURN
;
DIV_7       MOVLW   0x04         ; dividend + (99 - divisor + carry)
            MOVWF   CNT3
            LFSR    FSR0,0x053
            LFSR    FSR1,0x057
            BCF     STATUS,C     ; clr carry
DIV_70      MOVF    POSTDEC0, W
            ADDWFC  INDF1, W
            CALL    DEC_ADJ
            MOVWF   POSTDEC1
            DECFSZ  CNT3, F
            BRA     DIV_70
;
DIV_71      MOVF    DIV5,W       ; check if result zero
            IORWF   DIV6,W
            IORWF   DIV7,W
            IORWF   DIV8,W
            RETURN
;
CLR_CHAR    MOVLW   ' '
SEND_CHAR   MOVWF   CHAR            ; Character to be sent
            RCALL   CHK_LCD
            BSF     PORTB,6         ; rs=1 data
            BRA     SEND_INS1
;
SEND_INS    MOVWF   CHAR            ; Command to be sent
            RCALL   CHK_LCD
            BCF     PORTB,6         ; rs=0 command
;
SEND_INS1   MOVF    CHAR, W
            MOVWF   PORTC
            NOP
            NOP
            BSF     PORTB,1         ; E high for LCD
            NOP
            NOP
            BCF     PORTB,1         ; E low for LCD
            RETURN
;
CHK_LCD     MOVLW   0xFF
            MOVWF   TRISC           ; all inputs
            BSF     PORTB,7         ; set to read
            BCF     PORTB,6         ; rs=0 command
;
WAIT_LCD    BSF     PORTB,1         ; E high for LCD
            BTFSS   PORTC, 7
            BRA     RDY_LCD
            BCF     PORTB,1         ; E low for LCD
            BRA     WAIT_LCD
;
RDY_LCD     BCF     PORTB,1         ; E low for LCD
            BCF     PORTB,7         ; set to write
;
            MOVLW   0x00
            MOVWF   TRISC           ; all outputs
            RETURN
;
ASCII_Z0    MOVWF   TEMP
            SWAPF   TEMP, W
            RCALL   HEX_A_ZC
            BSF     BITS_BYTE,3     ;disable leading zero's blanking
            BRA     ASCII_1
;
ASCII_Z1    MOVWF   TEMP
            SWAPF   TEMP, W
            RCALL   HEX_A_Z
            BSF     BITS_BYTE,3     ;disable leading zero's blanking
            BRA     ASCII_1
;
ASCII_Z2    BCF     BITS_BYTE,3     ;enable leading zero's blanking
            BRA     ASCII_ZC
;
ASCII       BSF     BITS_BYTE,3     ;disable leading zero's blanking
ASCII_ZC    MOVWF   TEMP
            SWAPF   TEMP, W 
            RCALL   HEX_ASCII       ; convert ASCII
            RCALL   SEND_CHAR
ASCII_1     MOVF    TEMP, W
            BRA     HEX_A_ZC
;
HEX_A_Z     BCF     BITS_BYTE,3     ;enable leading zero's blanking
            BRA     HEX_A_ZC
;    
HEX_A       BSF     BITS_BYTE,3     ;disable leading zero's blanking
HEX_A_ZC    RCALL   HEX_ASCII
            BRA     SEND_CHAR       ; Return
;
HEX_ASCII   ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     HEX_ASCII_2
            BSF     BITS_BYTE,3     ;disable leading zero's blanking
HEX_ASCII_1 ADDLW   0x30            ;set to correct ascii
            RETURN
HEX_ASCII_2 BTFSC   BITS_BYTE,3     ;leading zero's blanking
            BRA     HEX_ASCII_1
            MOVLW   ' '
            RETURN
;
HEX_DEC     CLRF    DIV9
            CLRF    DIV10
HEX_DEC1    CLRF    DIV7
            CLRF    DIV8
            CLRF    DIV2
            CLRF    DIV1
            CLRF    DIV3
            CLRF    DIV5
            CLRF    DIV6
            BCF     STATUS,C
            BCF     STATUS,DC
            MOVF    DIV11,W
            ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     HEX_DEC2
            CALL    DEC_ADJ
            MOVWF   DIV8
;
HEX_DEC2    SWAPF   DIV11,W
            ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     HEX_DEC3
            MOVWF   CNT1
            MOVLW   0x16
            RCALL   ADD_NUM
;
HEX_DEC3    MOVF    DIV10,W
            ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     HEX_DEC4
            MOVWF   CNT1
            MOVLW   0x02
            MOVWF   DIV3
            MOVLW   0x56
            RCALL   ADD_NUM
;
HEX_DEC4    SWAPF   DIV10,W
            ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     HEX_DEC5
            MOVWF   CNT1
            MOVLW   0x40
            MOVWF   DIV3
            MOVLW   0x96
            RCALL   ADD_NUM
;
HEX_DEC5    MOVF    DIV9,W
            ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     HEX_DEC6
;
            MOVWF   CNT1
            MOVLW   0x06
            MOVWF   DIV2
            MOVLW   0x55
            MOVWF   DIV3
            MOVLW   0x36
            RCALL   ADD_NUM
;
HEX_DEC6    SWAPF   DIV9,W
            ANDLW   0x0F
            BTFSC   STATUS,Z
            RETURN
;
            MOVWF   CNT1
            MOVLW   0x01
            MOVWF   DIV1
            MOVLW   0x04
            MOVWF   DIV2
            MOVLW   0x85
            MOVWF   DIV3
            MOVLW   0x76
;
ADD_NUM     MOVWF   DIV4
ADD_NUMS    CALL    DIV_7
            DECFSZ  CNT1,F
            BRA     ADD_NUMS    ; add numbers
            RETURN
;
MULT0       CLRF    DIV1
            CLRF    DIV2
MULT        CLRF    DIV5
            CLRF    DIV6
            CLRF    DIV7
            CLRF    DIV8
            CLRF    DIV9
            CLRF    DIV10
            MOVF    DIV12,W         ; multiplier
            RCALL   MULT1
            SWAPF   DIV12,W
            RCALL   MULT1
            MOVF    DIV11,W
            RCALL   MULT1
            SWAPF   DIV11,W
            BRA     MULT1
;
MULT1       ANDLW   0x0F
            BTFSC   STATUS,Z
            BRA     MULT3
            MOVWF   CNT1
            RCALL   ADD_NUMS
;
MULT3       MOVLW   0x04
            MOVWF   CNT1
MULT4       MOVLW   0x06           ; move 6 numbers to right 4 places
            MOVWF   CNT3
            LFSR    FSR0,0x054
;
            BCF     STATUS, C      ; shift to right 4 places
MULT5       RRCF    POSTINC0,F
            DECFSZ  CNT3,F
            BRA     MULT5
            DECFSZ  CNT1,F
            BRA     MULT4
            RETURN
;
SAVE_VAL0   LFSR    FSR0,0x000     ; save
SAVE_VAL00  MOVF    INDF0,W       ; 4 - 10 ms per location
            MOVWF   TEMP
            MOVF    FSR0L,W
            RCALL   EE_WR
            MOVF    POSTINC0,W    ;dummy read
            MOVF    FSR0L,W
            SUBLW   0x0A
            BTFSS   STATUS,Z
            BRA     SAVE_VAL00
            RETURN
;
SAVE_VAL1   LFSR    FSR0,0x00A
SAVE_VAL10  MOVF    INDF0,W       ; 4 - 10 ms per location
            MOVWF   TEMP
            MOVF    FSR0L,W
            RCALL   EE_WR
            MOVF    POSTINC0,W    ;dummy read
            MOVF    FSR0L,W
            SUBLW   0x2D
            BTFSS   STATUS,Z
            BRA     SAVE_VAL10
            RETURN
;
EE_READ     MOVWF   EEADR
EE_READ0    BCF     EECON1, EEPGD
            BCF     EECON1, CFGS
            BSF     EECON1, RD
            MOVF    EEDATA, W
            RETURN
;
EE_WR       BCF     FUNC1,0
            MOVWF   EEADR
EE_WR0      MOVF    TEMP, W
            MOVWF   EEDATA
            BCF     EECON1, EEPGD
            BCF     EECON1, CFGS
            BSF     EECON1, WREN    ; enable writes
            BCF     INTCON, GIE     ; disable int
            MOVLW   0x55
            MOVWF   EECON2
            MOVLW   0xAA
            MOVWF   EECON2
            BSF     EECON1, WR
            BSF     INTCON, GIE     ; enable int
EE_WR1      NOP
            BTFSC   EECON1, WR
            BRA     EE_WR1
            BCF     EECON1, WREN    ; disable writes
            BCF     PIR2, EEIF      ; clr ee write int
;
            BTFSC   FUNC1,0
            RETURN
            BSF     FUNC1,0
            RCALL   EE_READ0        ; check if write OK
            XORWF   TEMP,W 
            BTFSC   STATUS, Z       ; skip if not equal
            RETURN
            BRA     EE_WR0
;
  end
